#ifndef _card_person_h_
#define _card_person_h_

#include "card_base.h"
#include "card_area.h"

struct person:card_location_base, card_area
{
	std::weak_ptr<monkey_person> m_monkeyPerson;
	int m_workLine=0;

	person(std::string type,uint32_t cardid,uint16_t needdisplay,int16_t t,int32_t deptid,int32_t level_id,uint32_t cid,int wl);
	~person();

	void on_message(zloop<task*> * loop,const message_locinfo&loc,bool is_history);

    void clear();
	void reset(std::shared_ptr<monkey_person> mp);
	void handle_three_rates(const point & pt);
	void on_timer();
	point getSmoothPoint(uint64_t& t);

	virtual void site_hover(int sid);
    virtual std::shared_ptr<area_hover> get_area_hover();
    virtual std::shared_ptr<mine_tool> get_mine_tool();
    virtual std::shared_ptr<site_area_hover> get_site_area();
	virtual void do_business(const point &pt,double acc);
};

#endif



